import {ItemGroup} from "./ItemGroup";
import {Item} from "./Item";
import {ItemGroupCharacteristic} from "./ItemgroupCharacteristic";

export class ConcreteItemGroup extends ItemGroup {

  items: Item[] = [];

  addItem(item: Item, parentItemgroups: ItemGroup[]) {
    if(this.findItemByName(item.componentName) == undefined) {
      parentItemgroups.forEach(itemgroup => {
        item.addInheritedHierarchyGroup(itemgroup);
      })
      this.items.push(item);
    }
  }

  findItemByName(itemName: string) {
    return this.items.find(item => item.componentName === itemName);
  }

  protected addCharacteristicValue(characteristic: ItemGroupCharacteristic): void {
    this.items.forEach(item => {
      item.addCharacteristic(characteristic);
    })
  }


}
